<template>
<div class="flex-box slider-css">
  <div class="channelTotal">
    <span>总通道{{channelTotal}}算力</span>
  </div>
  <div class="slider">
    <vue-slider v-model="PollData.sliderList"
    ref="sliderVideo"
    @change="changeSlider"
     v-bind="options" ></vue-slider>
  </div>
</div>
</template>
<script>
import VueSlider from 'vue-slider-component'
import 'vue-slider-component/theme/default.css'

export default {
  name: "slider",
  props: {
    channelTotal: {
      type:Number,
      default:16
    },
    list: {
      type:Array,
      default:()=>{
        //首尾表示滑块总长度，中间：实时、轮询、本地视频、本地图片、本地音频
        return []
      }
    }
  },
  components: {
    VueSlider
  },
  computed: {
    
  },
  watch: {
    list: {
      handler(newVal, oldVal){
        if(newVal !== oldVal){
          this.dataList = newVal
        }
      },
      deep:true
    },
    "PollData.sliderList": {
      handler(newVal, oldVal){
        if(newVal !== oldVal){
          // console.log(newVal,"watch sliderList",oldVal);
          if(this.PollData.sliderList[2] < this.PollData.channelTotal){
            this.PollData.sliderList.push(this.PollData.channelTotal)
          }
        }
      },
      deep: true
    }
  },
  data() {
    return {
      dataList: [],
      options: {
        dotSize: 14,
        width: 'auto',
        heght: 4,
        contained: false,
        direction: 'ltr',
	      data: null,
        min: 0,
        max: 16,
        interval: 1,
        disabled: false,
        clickable: true,
        duration: 0.5,
        adsorb: false,
        lazy: false,
        tooltip: 'focus',
        tooltipPlacement: 'top',
        tooltipFormatter: val => {
          let index = this.PollData.sliderList.indexOf(val)
          if(index == 0){
            return val
          }else if(index == 1){
            return `实时:${val - this.PollData.sliderList[index-1]}`
          }else if(index == 2){
            return `轮询:${val - this.PollData.sliderList[index-1]}`
          }else if(index == 3){
            return `本地视频:${val - this.PollData.sliderList[index-1]}`
          }else if(index == 4){
            return `本地图片:${val - this.PollData.sliderList[index-1]}`
          }else if(index == 5){
            return `本地音频:${val - this.PollData.sliderList[index-1]}`
          }
        },
        useKeyboard: false,
        enableCross: false, //是否允许滑块交叉
        fixed: false,
        minRange: void 0,
        maxRange: void 0,
        order: true,
        marks: false,
        dotOptions: [
          {
            disabled:true,
            style: {
              'height':'4px',
              'width':'4px',
              'position':'relative',
              'top':'5px',
              'left':'-3px',
              'background-color': '#fff',
              'box-shadow': 'none'
            }
          },
          {
            disabled:true,
            tooltip: 'always',
            tooltipStyle: {
              'background-color': 'red',
              'border-color': 'red',
              'font-size': '10px',
              'z-index': '10'
            },
            style: {
              'background-color': 'red',
              'z-index': 10
            }
          },
          {
            disabled:false,
            tooltip: 'always',
            tooltipStyle: {
              'background-color': '#3D68E1',
              'border-color': '#3D68E1',
              'font-size': '10px',
              'z-index': '9'
            },
            style: {
              'background-color': '#3D68E1',
              'z-index': 9
            }
          },
          {
            disabled:false,
            tooltip: 'always',
            tooltipStyle: {
              'background-color': '#2882CE',
              'border-color': '#2882CE',
              'font-size': '10px',
              'z-index': 8
            },
            style: {
              'background-color': '#2882CE',
              'z-index': 8
            },
            disabledStyle: {
              'z-index': 8
            }
          },
          {
            disabled:false,
            tooltip: 'always',
            tooltipStyle: {
              'background-color': '#F0B27A',
              'border-color': '#F0B27A',
              'font-size': '10px',
              'z-index': 2
            },
            style: {
              'background-color': '#F0B27A',
              'z-index': 2
            },
            disabledStyle: {
              'z-index': 2
            }
          },
          {
            disabled:true,
            tooltip: 'always',
            tooltipStyle: {
              'background-color': '#73C6B6',
              'border-color': '#73C6B6',
              'font-size': '10px',
              'z-index': 1
            },
            style: {
              'background-color': '#73C6B6',
              'z-index': 1
            },
            disabledStyle: {
              'z-index': 1
            }
          },
          // {
          //   //第六段：本来是作为终点的，现在是固定本地音频不动
          //   disabled:true,
          //   style: {
          //     'height':'4px',
          //     'width':'4px',
          //     'position':'relative',
          //     'top':'5px',
          //     'left':'10px',
          //     'background-color': '#fff',
          //     'box-shadow': 'none'
          //   }
          // }
        ],
        process: dotsPos => [
          [dotsPos[4], dotsPos[5], { backgroundColor: '#73C6B6' }],
          [dotsPos[3], dotsPos[4], { backgroundColor: '#F0B27A' }],
          [dotsPos[2], dotsPos[3], { backgroundColor: '#2882CE' }],
          [dotsPos[1], dotsPos[2], { backgroundColor: '#3D68E1' }],
          [dotsPos[0], dotsPos[1], { backgroundColor: 'red' }],
          // [dotsPos[2], dotsPos[6], { backgroundColor: 'orange' }],
          // [dotsPos[3], dotsPos[4], { backgroundColor: '#F0B27A' }],
          // [dotsPos[4], dotsPos[5], { backgroundColor: '#73C6B6' }],
        ],
        dotStyle: void 0,
        railStyle: void 0,
        processStyle: void 0,
        tooltipStyle: void 0,
        stepStyle: void 0,
        stepActiveStyle: void 0,
        labelStyle: void 0,
        labelActiveStyle: void 0,
      }
    }
  },
  methods: {
    changeSlider(val){
      //[0, 20, 44, 60, 70, 84, 100, __ob__: Observer] "滑块值变动"
      // console.log(val,'滑块值变动')
      if(val[val.length -1] < this.PollData.channelTotal){
        val.push(this.PollData.channelTotal)
      }
      this.$emit('changeSlider',val)
    },
    getIndex(){
      let index = this.$refs.sliderVideo.getIndex(2);
      console.log(index,'点击的索引')
    }
  },
  mounted() {
    this.datalist = this.list
  },
  created() {
    console.log(this.list,'slider-count')
  },
  destroyed() {
    
  }
}
</script>
<style lang="scss">
.slider-css {
  position: relative;
  top: 5px;
}
.channelTotal{
  width: 50px;
  margin-top: 14px;
}
.slider{
  width: calc(95% - 60px);
  padding: 20px;
}
</style>
